<?php

/*
* Copyright: (C) 2013 - 2021 José Conti
*/
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/*
* Copyright: (C) 2013 - 2021 José Conti
*/
function redsys_return_dserrors() {
	return array(
		'SIS0007' => esc_html__( 'Error al desmontar el XML de entrada' , 'woocommerce-redsys' ),
		'SIS0008' => esc_html__( 'Error falta Ds_Merchant_MerchantCode' , 'woocommerce-redsys' ),
		'SIS0009' => esc_html__( 'Error de formato en Ds_Merchant_MerchantCode' , 'woocommerce-redsys' ),
		'SIS0010' => esc_html__( 'Error falta Ds_Merchant_Terminal' , 'woocommerce-redsys' ),
		'SIS0011' => esc_html__( 'Error de formato en Ds_Merchant_Terminal' , 'woocommerce-redsys' ),
		'SIS0014' => esc_html__( 'Error de formato en Ds_Merchant_Order' , 'woocommerce-redsys' ),
		'SIS0015' => esc_html__( 'Error falta Ds_Merchant_Currency' , 'woocommerce-redsys' ),
		'SIS0016' => esc_html__( 'Error de formato en Ds_Merchant_Currency' , 'woocommerce-redsys' ),
		'SIS0017' => esc_html__( 'Error no se admiten operaciones en pesetas' , 'woocommerce-redsys' ),
		'SIS0018' => esc_html__( 'Error falta Ds_Merchant_Amount' , 'woocommerce-redsys' ),
		'SIS0019' => esc_html__( 'Error de formato en Ds_Merchant_Amount' , 'woocommerce-redsys' ),
		'SIS0020' => esc_html__( 'Error falta Ds_Merchant_MerchantSignature' , 'woocommerce-redsys' ),
		'SIS0021' => esc_html__( 'Error la Ds_Merchant_MerchantSignature viene vacía' , 'woocommerce-redsys' ),
		'SIS0022' => esc_html__( 'Error de formato en Ds_Merchant_TransactionType' , 'woocommerce-redsys' ),
		'SIS0023' => esc_html__( 'Error Ds_Merchant_TransactionType desconocido' , 'woocommerce-redsys' ),
		'SIS0024' => esc_html__( 'Error Ds_Merchant_ConsumerLanguage tiene mas de 3 posiciones' , 'woocommerce-redsys' ),
		'SIS0025' => esc_html__( 'Error de formato en Ds_Merchant_ConsumerLanguage' , 'woocommerce-redsys' ),
		'SIS0026' => esc_html__( 'Error No existe el comercio / terminal enviado' , 'woocommerce-redsys' ),
		'SIS0027' => esc_html__( 'Error Moneda enviada por el comercio es diferente a la que tiene asignada para ese terminal' , 'woocommerce-redsys' ),
		'SIS0028' => esc_html__( 'Error Comercio / terminal está dado de baja' , 'woocommerce-redsys' ),
		'SIS0030' => esc_html__( 'Error en un pago con tarjeta ha llegado un tipo de operación que no es ni pago ni preautorización' , 'woocommerce-redsys' ),
		'SIS0031' => esc_html__( 'Método de pago no definido' , 'woocommerce-redsys' ),
		'SIS0033' => esc_html__( 'Error en un pago con móvil ha llegado un tipo de operación que no es ni pago ni preautorización' , 'woocommerce-redsys' ),
		'SIS0034' => esc_html__( 'Error de acceso a la Base de Datos' , 'woocommerce-redsys' ),
		'SIS0037' => esc_html__( 'El número de teléfono no es válido' , 'woocommerce-redsys' ),
		'SIS0038' => esc_html__( 'Error en java' , 'woocommerce-redsys' ),
		'SIS0040' => esc_html__( 'Error el comercio / terminal no tiene ningún método de pago asignado' , 'woocommerce-redsys' ),
		'SIS0041' => esc_html__( 'Error en el cálculo de la HASH de datos del comercio.' , 'woocommerce-redsys' ),
		'SIS0042' => esc_html__( 'La firma enviada no es correcta' , 'woocommerce-redsys' ),
		'SIS0043' => esc_html__( 'Error al realizar la notificación on-line' , 'woocommerce-redsys' ),
		'SIS0046' => esc_html__( 'El bin de la tarjeta no está dado de alta' , 'woocommerce-redsys' ),
		'SIS0051' => esc_html__( 'Error número de pedido repetido' , 'woocommerce-redsys' ),
		'SIS0054' => esc_html__( 'Error no existe operación sobre la que realizar la devolución' , 'woocommerce-redsys' ),
		'SIS0055' => esc_html__( 'Error existe más de un pago con el mismo número de pedido' , 'woocommerce-redsys' ),
		'SIS0056' => esc_html__( 'La operación sobre la que se desea devolver no está autorizada' , 'woocommerce-redsys' ),
		'SIS0057' => esc_html__( 'El importe a devolver supera el permitido' , 'woocommerce-redsys' ),
		'SIS0058' => esc_html__( 'Inconsistencia de datos, en la validación de una confirmación' , 'woocommerce-redsys' ),
		'SIS0059' => esc_html__( 'Error no existe operación sobre la que realizar la confirmación' , 'woocommerce-redsys' ),
		'SIS0060' => esc_html__( 'Ya existe una confirmación asociada a la preautorización' , 'woocommerce-redsys' ),
		'SIS0061' => esc_html__( 'La preautorización sobre la que se desea confirmar no está autorizada' , 'woocommerce-redsys' ),
		'SIS0062' => esc_html__( 'El importe a confirmar supera el permitido' , 'woocommerce-redsys' ),
		'SIS0063' => esc_html__( 'Error. Número de tarjeta no disponible' , 'woocommerce-redsys' ),
		'SIS0064' => esc_html__( 'Error. El número de tarjeta no puede tener más de 19 posiciones' , 'woocommerce-redsys' ),
		'SIS0065' => esc_html__( 'Error. El número de tarjeta no es numérico' , 'woocommerce-redsys' ),
		'SIS0066' => esc_html__( 'Error. Mes de caducidad no disponible' , 'woocommerce-redsys' ),
		'SIS0067' => esc_html__( 'Error. El mes de la caducidad no es numérico' , 'woocommerce-redsys' ),
		'SIS0068' => esc_html__( 'Error. El mes de la caducidad no es válido' , 'woocommerce-redsys' ),
		'SIS0069' => esc_html__( 'Error. Año de caducidad no disponible' , 'woocommerce-redsys' ),
		'SIS0070' => esc_html__( 'Error. El Año de la caducidad no es numérico' , 'woocommerce-redsys' ),
		'SIS0071' => esc_html__( 'Tarjeta caducada' , 'woocommerce-redsys' ),
		'SIS0072' => esc_html__( 'Operación no anulable' , 'woocommerce-redsys' ),
		'SIS0074' => esc_html__( 'Error falta Ds_Merchant_Order' , 'woocommerce-redsys' ),
		'SIS0075' => esc_html__( 'Error el Ds_Merchant_Order tiene menos de 4 posiciones o más de 12' , 'woocommerce-redsys' ),
		'SIS0076' => esc_html__( 'Error el Ds_Merchant_Order no tiene las cuatro primeras posiciones numéricas' , 'woocommerce-redsys' ),
		'SIS0077' => esc_html__( 'Error el Ds_Merchant_Order no tiene las cuatro primeras posiciones numéricas. No se utiliza' , 'woocommerce-redsys' ),
		'SIS0078' => esc_html__( 'Método de pago no disponible' , 'woocommerce-redsys' ),
		'SIS0079' => esc_html__( 'Error al realizar el pago con tarjeta' , 'woocommerce-redsys' ),
		'SIS0081' => esc_html__( 'La sesión es nueva, se han perdido los datos almacenados' , 'woocommerce-redsys' ),
		'SIS0084' => esc_html__( 'El valor de Ds_Merchant_Conciliation es nulo' , 'woocommerce-redsys' ),
		'SIS0085' => esc_html__( 'El valor de Ds_Merchant_Conciliation no es numérico' , 'woocommerce-redsys' ),
		'SIS0086' => esc_html__( 'El valor de Ds_Merchant_Conciliation no ocupa 6 posiciones' , 'woocommerce-redsys' ),
		'SIS0089' => esc_html__( 'El valor de Ds_Merchant_ExpiryDate no ocupa 4 posiciones' , 'woocommerce-redsys' ),
		'SIS0092' => esc_html__( 'El valor de Ds_Merchant_ExpiryDate es nulo' , 'woocommerce-redsys' ),
		'SIS0093' => esc_html__( 'Tarjeta no encontrada en la tabla de rangos' , 'woocommerce-redsys' ),
		'SIS0094' => esc_html__( 'La tarjeta no fue autenticada como 3D Secure' , 'woocommerce-redsys' ),
		'SIS0097' => esc_html__( 'Valor del campo Ds_Merchant_CComercio no válido' , 'woocommerce-redsys' ),
		'SIS0098' => esc_html__( 'Valor del campo Ds_Merchant_CVentana no válido' , 'woocommerce-redsys' ),
		'SIS0112' => esc_html__( 'Error El tipo de transacción especificado en Ds_Merchant_Transaction_Type no esta permitido' , 'woocommerce-redsys' ),
		'SIS0113' => esc_html__( 'Excepción producida en el servlet de operaciones' , 'woocommerce-redsys' ),
		'SIS0114' => esc_html__( 'Error, se ha llamado con un GET en lugar de un POST' , 'woocommerce-redsys' ),
		'SIS0115' => esc_html__( 'Error no existe operación sobre la que realizar el pago de la cuota' , 'woocommerce-redsys' ),
		'SIS0116' => esc_html__( 'La operación sobre la que se desea pagar una cuota no es una operación válida' , 'woocommerce-redsys' ),
		'SIS0117' => esc_html__( 'La operación sobre la que se desea pagar una cuota no está autorizada' , 'woocommerce-redsys' ),
		'SIS0118' => esc_html__( 'Se ha excedido el importe total de las cuotas' , 'woocommerce-redsys' ),
		'SIS0119' => esc_html__( 'Valor del campo Ds_Merchant_DateFrecuency no válido' , 'woocommerce-redsys' ),
		'SIS0120' => esc_html__( 'Valor del campo Ds_Merchant_ChargeExpiryDate no válido' , 'woocommerce-redsys' ),
		'SIS0121' => esc_html__( 'Valor del campo Ds_Merchant_SumTotal no válido' , 'woocommerce-redsys' ),
		'SIS0122' => esc_html__( 'Valor del campo Ds_Merchant_DateFrecuency o no Ds_Merchant_SumTotal tiene formato incorrecto' , 'woocommerce-redsys' ),
		'SIS0123' => esc_html__( 'Se ha excedido la fecha tope para realizar transacciones' , 'woocommerce-redsys' ),
		'SIS0124' => esc_html__( 'No ha transcurrido la frecuencia mínima en un pago recurrente sucesivo' , 'woocommerce-redsys' ),
		'SIS0132' => esc_html__( 'La fecha de Confirmación de Autorización no puede superar en más de 7 días a la de Preautorización.' , 'woocommerce-redsys' ),
		'SIS0133' => esc_html__( 'La fecha de Confirmación de Autenticación no puede superar en más de 45 días a la de Autenticación Previa.' , 'woocommerce-redsys' ),
		'SIS0139' => esc_html__( 'Error el pago recurrente inicial está duplicado' , 'woocommerce-redsys' ),
		'SIS0142' => esc_html__( 'Tiempo excedido para el pago' , 'woocommerce-redsys' ),
		'SIS0197' => esc_html__( 'Error al obtener los datos de cesta de la compra en operación tipo pasarela' , 'woocommerce-redsys' ),
		'SIS0198' => esc_html__( 'Error el importe supera el límite permitido para el comercio' , 'woocommerce-redsys' ),
		'SIS0199' => esc_html__( 'Error el número de operaciones supera el límite permitido para el comercio' , 'woocommerce-redsys' ),
		'SIS0200' => esc_html__( 'Error el importe acumulado supera el límite permitido para el comercio' , 'woocommerce-redsys' ),
		'SIS0214' => esc_html__( 'El comercio no admite devoluciones' , 'woocommerce-redsys' ),
		'SIS0216' => esc_html__( 'Error Ds_Merchant_CVV2 tiene más de 3 posiciones' , 'woocommerce-redsys' ),
		'SIS0217' => esc_html__( 'Error de formato en Ds_Merchant_CVV2' , 'woocommerce-redsys' ),
		'SIS0218' => esc_html__( 'El comercio no permite operaciones seguras por la entrada/operaciones' , 'woocommerce-redsys' ),
		'SIS0219' => esc_html__( 'Error el número de operaciones de la tarjeta supera el límite permitido para el comercio' , 'woocommerce-redsys' ),
		'SIS0220' => esc_html__( 'Error el importe acumulado de la tarjeta supera el límite permitido para el comercio' , 'woocommerce-redsys' ),
		'SIS0221' => esc_html__( 'Error el CVV2 es obligatorio' , 'woocommerce-redsys' ),
		'SIS0222' => esc_html__( 'Ya existe una anulación asociada a la preautorización' , 'woocommerce-redsys' ),
		'SIS0223' => esc_html__( 'La preautorización que se desea anular no está autorizada' , 'woocommerce-redsys' ),
		'SIS0224' => esc_html__( 'El comercio no permite anulaciones por no tener firma ampliada' , 'woocommerce-redsys' ),
		'SIS0225' => esc_html__( 'Error no existe operación sobre la que realizar la anulación' , 'woocommerce-redsys' ),
		'SIS0226' => esc_html__( 'Inconsistencia de datos, en la validación de una anulación' , 'woocommerce-redsys' ),
		'SIS0227' => esc_html__( 'Valor del campo Ds_Merchant_TransactionDate no válido' , 'woocommerce-redsys' ),
		'SIS0229' => esc_html__( 'No existe el código de pago aplazado solicitado' , 'woocommerce-redsys' ),
		'SIS0231' => esc_html__( 'No hay forma de pago aplicable para el cliente' , 'woocommerce-redsys' ),
		'SIS0232' => esc_html__( 'Error. Forma de pago enviada en Ds_Merchant_Paymethods no disponible' , 'woocommerce-redsys' ),
		'SIS0233' => esc_html__( 'Error. Forma de pago enviada en Ds_Merchant_Paymethods desconocida' , 'woocommerce-redsys' ),
		'SIS0234' => esc_html__( 'Error. Nombre del titular de la cuenta no disponible' , 'woocommerce-redsys' ),
		'SIS0235' => esc_html__( 'Error. Campo Sis_Numero_Entidad no disponible' , 'woocommerce-redsys' ),
		'SIS0236' => esc_html__( 'Error. El campo Sis_Numero_Entidad no tiene la longitud requerida' , 'woocommerce-redsys' ),
		'SIS0237' => esc_html__( 'Error. El campo Sis_Numero_Entidad no es numérico' , 'woocommerce-redsys' ),
		'SIS0238' => esc_html__( 'Error. Campo Sis_Numero_Oficina no disponible' , 'woocommerce-redsys' ),
		'SIS0239' => esc_html__( 'Error. El campo Sis_Numero_Oficina no tiene la longitud requerida' , 'woocommerce-redsys' ),
		'SIS0240' => esc_html__( 'Error. El campo Sis_Numero_Oficina no es numérico' , 'woocommerce-redsys' ),
		'SIS0241' => esc_html__( 'Error. Campo Sis_Numero_DC no disponible' , 'woocommerce-redsys' ),
		'SIS0242' => esc_html__( 'Error. El campo Sis_Numero_DC no tiene la longitud requerida' , 'woocommerce-redsys' ),
		'SIS0243' => esc_html__( 'Error. El campo Sis_Numero_DC no es numérico' , 'woocommerce-redsys' ),
		'SIS0244' => esc_html__( 'Error. Campo Sis_Numero_Cuenta no disponible' , 'woocommerce-redsys' ),
		'SIS0245' => esc_html__( 'Error. El campo Sis_Numero_Cuenta no tiene la longitud requerida' , 'woocommerce-redsys' ),
		'SIS0246' => esc_html__( 'Error. El campo Sis_Numero_Cuenta no es numérico' , 'woocommerce-redsys' ),
		'SIS0247' => esc_html__( 'Dígito de Control de Cuenta Cliente no válido' , 'woocommerce-redsys' ),
		'SIS0248' => esc_html__( 'El comercio no permite pago por domiciliación' , 'woocommerce-redsys' ),
		'SIS0249' => esc_html__( 'Error al realizar pago por domiciliacion' , 'woocommerce-redsys' ),
		'SIS0250' => esc_html__( 'Error al tomar los datos del XML para realizar Pago por Transferencia' , 'woocommerce-redsys' ),
		'SIS0251' => esc_html__( 'El comercio no permite pago por transferencia' , 'woocommerce-redsys' ),
		'SIS0262' => esc_html__( 'Moneda no permitida para operación de transferencia o domiciliacion' , 'woocommerce-redsys' ),
		'SIS0263' => esc_html__( 'Error calculando datos para procesar operación en Linea Abierta Caixa' , 'woocommerce-redsys' ),
		'SIS0264' => esc_html__( 'Error procesando datos de respuesta recibidos desde Linea Abierta Caixa' , 'woocommerce-redsys' ),
		'SIS0265' => esc_html__( 'Error de firma en los datos recibidos desde Linea Abierta Caixa' , 'woocommerce-redsys' ),
		'SIS0266' => esc_html__( 'No se pueden recuperar los datos de la operación recibida desde Linea Abierta Caixa' , 'woocommerce-redsys' ),
		'SIS0267' => esc_html__( 'La operación no se puede procesar por no existir Codigo Cuenta Cliente' , 'woocommerce-redsys' ),
		'SIS0268' => esc_html__( 'La operación no se puede procesar por este canal' , 'woocommerce-redsys' ),
		'SIS0269' => esc_html__( 'No se pueden realizar devoluciones de operaciones de domiciliacion no descargadas ' , 'woocommerce-redsys' ),
		'SIS0252' => esc_html__( 'El comercio no permite el envío de tarjeta' , 'woocommerce-redsys' ),
		'SIS0253' => esc_html__( 'La tarjeta no cumple el check-digit' , 'woocommerce-redsys' ),
		'SIS0254' => esc_html__( 'El número de operaciones de la IP supera el límite permitido por el comercio' , 'woocommerce-redsys' ),
		'SIS0255' => esc_html__( 'El importe acumulado por la IP supera el límite permitido por el comercio' , 'woocommerce-redsys' ),
		'SIS0256' => esc_html__( 'El comercio no puede realizar preautorizaciones' , 'woocommerce-redsys' ),
		'SIS0257' => esc_html__( 'Esta tarjeta no permite operativa de preautorizaciones' , 'woocommerce-redsys' ),
		'SIS0258' => esc_html__( 'Inconsistencia de datos, en la validación de una confirmación' , 'woocommerce-redsys' ),
		'SIS0261' => esc_html__( 'Operación detenida por superar el control de restricciones en la entrada al SIS' , 'woocommerce-redsys' ),
		'SIS0270' => esc_html__( 'El comercio no puede realizar autorizaciones en diferido' , 'woocommerce-redsys' ),
		'SIS0274' => esc_html__( 'Tipo de operación desconocida o no permitida por esta entrada al SIS' , 'woocommerce-redsys' ),
		'SIS0429' => esc_html__( 'Error en la versión enviada por el comercio en el parámetro Ds_SignatureVersion' , 'woocommerce-redsys' ),
		'SIS0430' => esc_html__( 'Error al decodificar el parámetro Ds_MerchantParameters' , 'woocommerce-redsys' ),
		'SIS0431' => esc_html__( 'Error del objeto JSON que se envía codificado en el parámetro Ds_MerchantParameters' , 'woocommerce-redsys' ),
		'SIS0432' => esc_html__( 'Error FUC del comercio erróneo' , 'woocommerce-redsys' ),
		'SIS0433' => esc_html__( 'Error Terminal del comercio erróneo' , 'woocommerce-redsys' ),
		'SIS0434' => esc_html__( 'Error ausencia de número de pedido en la operación enviada por el comercio' , 'woocommerce-redsys' ),
		'SIS0435' => esc_html__( 'Error en el cálculo de la firma' , 'woocommerce-redsys' ),
		'SIS0444' => esc_html__( 'Error producido al acceder mediante un sistema de firma antiguo teniendo configurado el tipo de clave HMAC SHA256' , 'woocommerce-redsys' ),
		'SIS0448' => esc_html__( 'Error, la tarjeta de la operación es DINERS y el comercio no tiene el método de pago "Pago DINERS"' , 'woocommerce-redsys' ),
		'SIS0449' => esc_html__( 'Error, el tipo de pago de la operación Ds_TransactionType (A) no está permitido para el comercio.' , 'woocommerce-redsys' ),
		'SIS0450' => esc_html__( 'Error, el tipo de pago de la operación Ds_TransactionType (A) no está permitido para el comercio para tarjetas Amex.' , 'woocommerce-redsys' ),
		'SIS0452' => esc_html__( 'Método de pago no disponible (Tarjeta 4B)' , 'woocommerce-redsys' ),
		'SIS0453' => esc_html__( 'Error, la tarjeta de la operación es JCB y el comercio no tiene el método de pago "Pago JCB"' , 'woocommerce-redsys' ),
		'SIS0454' => esc_html__( 'Error, la tarjeta de la operación es AMEX y el comercio no tiene el método de pago "Pago Amex"' , 'woocommerce-redsys' ),
		'SIS0455' => esc_html__( 'Método de pago no disponible' , 'woocommerce-redsys' ),
		'SIS0456' => esc_html__( 'Método de pago no seguro (Visa) no disponible' , 'woocommerce-redsys' ),
		'SIS0457' => esc_html__( 'Método de pago no seguro (MasterCard) no disponible' , 'woocommerce-redsys' ),
		'SIS0458' => esc_html__( 'Método de pago no seguro (MasterCard) no disponible' , 'woocommerce-redsys' ),
		'SIS0459' => esc_html__( 'Método de pago no seguro (JCB) no disponible' , 'woocommerce-redsys' ),
		'SIS0460' => esc_html__( 'Método de pago no seguro (Amex) no disponible' , 'woocommerce-redsys' ),
		'SIS0461' => esc_html__( 'Método de pago no seguro (Amex) no disponible' , 'woocommerce-redsys' ),
		'SIS0463' => esc_html__( 'Método de pago no disponible' , 'woocommerce-redsys' ),
		'SIS0464' => esc_html__( 'Método de pago no seguro no disponible (MasterCard Comercial)' , 'woocommerce-redsys' ),
		'SIS0465' => esc_html__( 'Método de pago no seguro no disponible' , 'woocommerce-redsys' ),
		'SIS0469' => esc_html__( 'Error, no se ha superado el proceso de control de fraude.' , 'woocommerce-redsys' ),
		'SIS0487' => esc_html__( 'Error, el comercio no tiene el método de pago Paygold' , 'woocommerce-redsys' ),
		'SIS0488' => esc_html__( 'Error, el comercio no tiene el método de pago Pago Manual' , 'woocommerce-redsys' ),
		'SIS0298' => esc_html__( 'El comercio no permite realizar operaciones de Trajetas de Archivo' , 'woocommerce-redsys' ),
		'SIS0319' => esc_html__( 'El comercio no pertenece al grupo especificado en Ds_Merchant_Group' , 'woocommerce-redsys' ),
		'SIS0321' => esc_html__( 'La referencia indicada en Ds_Merchant_Identifier no está asociada al comercio' , 'woocommerce-redsys' ),
		'SIS0322' => esc_html__( 'Error de formato en Ds_Merchant_Group' , 'woocommerce-redsys' ),
		'SIS0325' => esc_html__( 'Se ha pedido no mostrar pantalla pero no se ha enviado ninguna referencia de tarjeta' , 'woocommerce-redsys' ),
	);
}
